一个数组的 异或总和 定义为数组中所有元素按位 XOR 的结果;如果数组为 空 ,则异或总和为 0 。
- 例如,数组
[2,5,6]的 异或总和 为2 XOR 5 XOR 6 = 1。
给你一个数组 nums ,请你求出 nums 中每个 子集 的 异或总和 ,计算并返回这些值相加之 和 。
注意:在本题中,元素 相同 的不同子集应 多次 计数。
数组 a 是数组 b 的一个 子集 的前提条件是:从 b 删除几个(也可能不删除)元素能够得到 a 。
示例 1:
输入:nums = [1,3]
输出:6
解释:[1,3] 共有 4 个子集:
- 空子集的异或总和是 0 。
- [1] 的异或总和为 1 。
- [3] 的异或总和为 3 。
- [1,3] 的异或总和为 1 XOR 3 = 2 。
0 + 1 + 3 + 2 = 6示例 2:
输入:nums = [5,1,6]
输出:28
解释:[5,1,6] 共有 8 个子集:
- 空子集的异或总和是 0 。
- [5] 的异或总和为 5 。
- [1] 的异或总和为 1 。
- [6] 的异或总和为 6 。
- [5,1] 的异或总和为 5 XOR 1 = 4 。
- [5,6] 的异或总和为 5 XOR 6 = 3 。
- [1,6] 的异或总和为 1 XOR 6 = 7 。
- [5,1,6] 的异或总和为 5 XOR 1 XOR 6 = 2 。
0 + 5 + 1 + 6 + 4 + 3 + 7 + 2 = 28示例 3:
输入:nums = [3,4,5,6,7,8]
输出:480
解释:每个子集的全部异或总和值之和为 480 。提示:
1 <= nums.length <= 121 <= nums[i] <= 20
解题思路:子集问题解法(回溯 + 剪枝)
这道题其实变相在考察子集问题,因为它要求的就是将所有的子集的异或结果累加起来,那么我们只需要像求解子集问题时候一样,求出每个子集序列,然后算出它的异或结果,累加到一个全局变量 sum 上去,最后返回 sum 即可!
只不过我们其实可以不用每次得到一个子集序列后再去遍历子集序列求异或结果,这样子时间复杂度是比较高的,我们可以用一个变量 path 记录下路径上已经遍历到的元素的异或结果,然后让其再异或上当前的元素,得到就是当前子集的异或结果,最后将其累加到 sum 变量上即可!仅仅用一个变量就能得到这个效果,只不过我们需要注意的是因为我们要列举出其它的同层路径,所以回溯的时候需要将临时变量 path 恢复到原来的样子,只需要让其再次异或上当前元素即可做到!
剩下的其实细节和子集问题都是一样的,具体可以参考子集问题的笔记!
class Solution {
private:
int path = 0; // 存放当前路径的异或结果
int sum = 0; // 结果集,存放所有异或结果的和
public:
int subsetXORSum(vector<int>& nums) {
dfs(nums, 0);
return sum;
}
void dfs(vector<int>& nums, int index)
{
// 递归函数出口(其实也可以不写,因为下面的循环已经限制了在数组范围内了
if(index >= nums.size())
return;
for(int i = index; i < nums.size(); ++i)
{
// 处理当前结果
path ^= nums[i];
sum += path;
// 递归处理其它结果
dfs(nums, i + 1);
// 回溯处理
path ^= nums[i];
}
}
};